#include <iostream>
#include "../Include/nsSysteme.h"
#include "../Include/CException.hpp"

#include <fcntl.h>
#include <signal.h>
#include <unistd.h> // pause (), getpid (), getppid ()
#include <cstring> // strsignal ()
#include <sys/wait.h> //waitpid ()
#include <cassert>
using namespace std;

using namespace nsSysteme; // wrappers système
using namespace std;
using namespace nsUtil; //CException


void derout (int numSig) {
    cout << "j'ai recu le signal " << numSig << endl;
    cout << "mon nom c'est " << strsignal(numSig) << endl;
    cout << "mon pid est : " << getpid () << endl;
}


int ppal () {
    cout << "je suis le process de pid : " << getpid () << endl;
    cout << "mon père a pour de pid : " << getppid () << endl;
    return 0;
} // ppal ()


//on identifie le père et le fils avant / après appel a Fork ();
int ppal1 (){
    cout << "----------------" << endl
         << "avant l'appel de fork ()" << endl
         << "----------------"  << endl;

    cout << "je suis le process de pid : " << getpid () << endl;
    cout << "mon père a pour de pid : " << getppid () << endl;
    cout << "----------------"  << endl;
    if (Fork () > 0){ //code du processus père
        cout << "----------------" << endl
             << "apres l'appel de fork () - bloc si" << endl
             << "----------------"  << endl;
        cout << "je suis le process de pid : " << getpid () << endl;
        cout << "mon père a pour de pid : " << getppid () << endl;
      //  sleep (4);
    }
    else { //code du processus fils
       // sleep (2);
        cout << "----------------" << endl
             << "apres l'appel de fork () - bloc sinon" << endl
             << "----------------"  << endl;
        cout << "je suis le process de pid : " << getpid () << endl;
        cout << "mon père a pour de pid : " << getppid () << endl;
    }
    return 0;
}


//on identifie le père et le fils avant / après appel a Fork ()
// on execucte du code apres avoir ferme le bloc sinon
int ppal2 (){
    cout << "----------------" << endl
         << "avant l'appel de fork ()" << endl
         << "----------------"  << endl;

    cout << "je suis le process de pid : " << getpid () << endl;
    cout << "mon père a pour de pid : " << getppid () << endl;
    cout << "----------------"  << endl;
    if (Fork () > 0){ //code du processus père
        cout << "----------------" << endl
             << "apres l'appel de fork () - bloc si" << endl
             << "----------------"  << endl;
        cout << "je suis le process de pid : " << getpid () << endl;
        cout << "mon père a pour de pid : " << getppid () << endl;
        //sleep (4);
    }
    else { //code du processus fils
        //sleep (2);
        cout << "----------------" << endl
             << "apres l'appel de fork () - bloc sinon" << endl
             << "----------------"  << endl;
        cout << "je suis le process de pid : " << getpid () << endl;
        cout << "mon père a pour de pid : " << getppid () << endl;
    }
    cout << "j'execute du code " << endl;
    return 0;
}


//Oh une commande systeme :)
int ppal3 () {
    string cmd ("echo coucou");
    System (cmd.c_str());
    return 0;
}


int ppal4 () {
    for (unsigned i (0); i < 3 ; ++i) {
        if (Fork () > 0) {while (true);}
        else {
            ppal3 ();
        }
    }
    return 0;
}

int ppal5 () {
    for (unsigned i (0); i < 3 ; ++i) {
        if (Fork () > 0) {}
        else {
            ppal3 ();
        }
    }
    return 0;
}


int ppal6 () {
    for (unsigned i (0); i < 3 ; ++i) {
        if (Fork () > 0) {}
        else {
            ppal3 ();
        }
    }
    cout << "je suis le père originel" << endl;
    return 0;
}



int ppal51 () {
    while (true) {
        if (Fork () > 0) {}
        else {
            ppal3 ();
        }
    }
    return 0;
}



int ppal52 () {
    while (true) {
        if (Fork () > 0) {
            ppal3 ();
        }
        else {
            ppal3 ();
        }
    }
    return 0;
}

//Quid des variables - heritage valeurs "constantes"
int ppal7 (){
    int i (42);
    cout << "----------------" << endl
         << "avant l'appel de fork ()" << endl
         << "----------------"  << endl;

    cout << "je suis le process de pid : " << getpid () << endl;
    cout << "mon père a pour de pid : " << getppid () << endl;
    cout << "la valeur de i a cet endroit du code est : " << i << endl;
    cout << "----------------"  << endl;
    ++i;
    if (Fork () > 0){ //code du processus père
        cout << "----------------" << endl
             << "apres l'appel de fork () - bloc si" << endl
             << "----------------"  << endl;
        cout << "je suis le process de pid : " << getpid () << endl;
        cout << "mon père a pour de pid : " << getppid () << endl;
        cout << "la valeur de i a cet endroit du code est : " << i << endl;
        sleep (4);
    }
    else { //code du processus fils
        sleep (2);
        cout << "----------------" << endl
             << "apres l'appel de fork () - bloc sinon" << endl
             << "----------------"  << endl;
        cout << "je suis le process de pid : " << getpid () << endl;
        cout << "mon père a pour de pid : " << getppid () << endl;
        cout << "la valeur de i a cet endroit du code est : " << i << endl;
    }
    return 0;
}

int inc (int & i ){
    ++i;
    return i;
}

int ppal71 (){
    int j (0);
    for (unsigned i (0); i < 3 ; ++i) {
        if (Fork () > 0) {}
        else {
            j = inc (j);
        }
    }
    assert (j == 7);
    return 0;

}
//Question : comment on arrive à n'executer du code que
//pour le processus qui lance tous les autres
int ppal8 () {
    pid_t pidDuPadre = getpid();
    for (unsigned i (0); i < 3 ; ++i) {
        if (Fork () > 0) {}
        else {
            ppal3 ();
        }
    }
    if (getpid() == pidDuPadre)
        cout << "je suis le père originel" << endl;
    return 0;
}

//comportement des fichiers & multi-processus - #1 (2 processus)
int ppal9 () {
    int fdInitial = Open("Makefile",  O_RDONLY);
    int fdDest = Open ("Makefile_cpy", O_CREAT | O_WRONLY, 0700);
    char tampon [256];

    if (Fork () > 0) { //padre
        for (int nbOctetLus; (nbOctetLus = Read (fdInitial, tampon, 256));)
            Write(fdDest, tampon, nbOctetLus);
    }
    else { //fiston
        for (int nbOctetLus; (nbOctetLus = Read (fdInitial, tampon, 256));)
            Write(fdDest, tampon, nbOctetLus);
    }
    Close (fdInitial);
    Close (fdDest);
    return 0;
}

//comportement des fichiers & multi-processus - #2 (2^n -1 processus)
//faire plusieurs tests
int ppal10 () {
    int fdInitial = Open("Makefile",  O_RDONLY);
    int fdDest = Open ("Makefile_cpy", O_CREAT | O_WRONLY, 0700);
    char tampon [256];
    for (unsigned i(0); i < 10; ++i)
        if (Fork () > 0) { //padre
            for (int nbOctetLus; (nbOctetLus = Read (fdInitial, tampon, 256));)
                Write(fdDest, tampon, nbOctetLus);
        }
        else { //fiston
            for (int nbOctetLus; (nbOctetLus = Read (fdInitial, tampon, 256));)
                Write(fdDest, tampon, nbOctetLus);
        }
    Close (fdInitial);
    Close (fdDest);
    return 0;
}

//comportement des fichiers & multi-processus - #2 (2^n -1 processus)
//faire plusieurs tests
int ppal11 () {
    int fdInitial = Open("Makefile",  O_RDONLY);
    int fdDest = Open ("Makefile_cpy", O_CREAT | O_WRONLY, 0700);
    char tampon [256];
    for (unsigned i(0); i < 10; ++i)
        if (Fork () > 0) { //padre
            for (int nbOctetLus; (nbOctetLus = Read (fdInitial, tampon, 256));)
                Write(fdDest, tampon, nbOctetLus);
            Close (fdInitial);
        }
        else { //fiston
            for (int nbOctetLus; (nbOctetLus = Read (fdInitial, tampon, 256));)
                Write(fdDest, tampon, nbOctetLus);
            Close (fdDest);
        }
    return 0;
}

//deroutement de signaux dans les processus
int ppal12 () {
    Signal (SIGUSR1, derout);
    if (Fork () > 0) { //padre
        cout << getpid () << endl;
        while (true);
    }
    else { //fiston
        cout << getpid () << endl;
        while (true);
    }
    return 0;
}

//deroutement de SIGCHLD
//question : expliquer pourquoi on recoit 2 fois SIGCHLD
int ppal13 () {
    Signal (SIGCHLD, derout);
    if (Fork () > 0) { //padre
        cout << getpid () << endl;
        while (true);
    }
    else { //fiston
        cout << getpid () << endl;
        Kill (getppid (), SIGCHLD);
    }
    return 0;
}

//question : est-ce que le déroutement de SIGCHLD permet
//de se protéger des zombis ?



int main () {
    try {
        //ppal == programme principal
        return ppal2 ();
    }
    catch (const CException & Exc) {
        cerr << Exc << endl;
        return errno;
    }
    catch (const exception & Exc) {
        cerr << "Exception : " << Exc.what () << endl;
        return CstExcStd;
    }
    catch (...) {
        cerr << "Exception inconnue recue dans la fonction main()" << endl;
        return CstExcInconnue;
    }
}// main()
